'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _createExpressions = require('./createExpressions');

var _isReactComponent = require('./isReactComponent');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var findTarget = function findTarget(path) {
  if (t.isArrowFunctionExpression(path) || t.isFunctionExpression(path)) {
    var declarationPath = path.findParent(function (parentPath) {
      return t.isVariableDeclaration(parentPath);
    });

    return findTarget(declarationPath);
  }

  if (t.isExportDeclaration(path.parent)) return path.findParent(function (parentPath) {
    return t.isExportDeclaration(parentPath);
  });
  if (t.isExpression(path)) return path.findParent(function (parentPath) {
    return t.isDeclaration(parentPath);
  });

  return path;
};

var pushToClassBody = function pushToClassBody(_ref, expression) {
  var body = _ref.node.body.body;
  return body.push(expression);
};

var insertAfterPath = function insertAfterPath(_ref2) {
  var identifier = _ref2.identifier,
      path = _ref2.path,
      props = _ref2.props;

  if ((0, _isReactComponent.isClass)(path)) {
    pushToClassBody(path, (0, _createExpressions.createClassProperty)(props));
    return;
  }

  findTarget(path).insertAfter((0, _createExpressions.createFunctionProperty)(identifier, props));
};

var insertEntries = function insertEntries(entries, _ref3) {
  var _ref3$ignoredProps = _ref3.ignoredProps,
      ignoredProps = _ref3$ignoredProps === undefined ? [] : _ref3$ignoredProps;

  _lodash2.default.forEach(_lodash2.default.map(entries, function (_ref4) {
    var props = _ref4.props,
        rest = _objectWithoutProperties(_ref4, ['props']);

    return _extends({}, rest, {
      props: _lodash2.default.without.apply(_lodash2.default, [props].concat(_toConsumableArray(ignoredProps)))
    });
  }), insertAfterPath);
};

exports.default = insertEntries;